/*
Copyright (C) 2001-2002 Tomas Jakobsson.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include	"../quakedef.h"
#include	"../game.h"

void InitTrigger (edict_t *ent)
{
	ent->game.solid		= SOLID_TRIGGER;

	Setmodel (ent, ent->v.model);

	ent->game.movetype	= MOVETYPE_NONE;
	ent->v.modelindex	= 0;
	ent->v.model		= "";
}

void lap_trigger1_touch (void)
{
	edict_t	*other;
	int		i;

	other = miniracer.other;

	if (other->game.laptrigger != 3)
		return;

	other->game.laptrigger = 1;

	i = other->game.laps;

	if (!other->game.laptime[i])
	{
		other->game.laptime[i]	= sv.time - other->game.laptime[0] - other->game.laptime[4];
		other->game.laptime[4]	= other->game.laptime[4] + other->game.laptime[i];
	}

	if (other->game.laps == 3)
	{
		float	fastestlap;

		fastestlap 	= Min3 (other->game.laptime[1], other->game.laptime[2], other->game.laptime[3]);

		VectorCopy (miniracer.finishpoint[miniracer.FinishPlace].origin, other->game.goalorigin);
		
		miniracer.FinishPlace += 1;

		other->game.solid		= SOLID_NOT;

		other->game.ideal_yaw	= 180;
		other->game.yaw_speed	= 5;
		other->game.fly			= true;

		MSG_WriteByte  (&sv.reliable_datagram, svc_updatetime);
		MSG_WriteByte  (&sv.reliable_datagram, other->game.ClientNo);
		MSG_WriteFloat (&sv.reliable_datagram, other->game.laptime[4]);
		MSG_WriteFloat (&sv.reliable_datagram, fastestlap);
		MSG_WriteByte  (&sv.reliable_datagram, svc_raceover);
		MSG_WriteByte  (&sv.reliable_datagram, other->game.ClientNo);

		RestartTimer ();
	}

	other->game.laps += 1;

	MSG_WriteByte (&sv.reliable_datagram, svc_updatelaps);
	MSG_WriteByte (&sv.reliable_datagram, other->game.ClientNo);
	MSG_WriteByte (&sv.reliable_datagram, other->game.laps);
}

void lap_trigger2_touch (void)
{
	edict_t	*other;

	other = miniracer.other;

	if (other->game.laptrigger != 1)
		return;

	other->game.laptrigger = 2;
}

void lap_trigger3_touch (void)
{
	edict_t	*other;

	other = miniracer.other;

	if (other->game.laptrigger != 2)
		return;

	other->game.laptrigger = 3;
}

void LapTrigger1 (void)
{
	edict_t	*ent;

	ent = miniracer.self;

	InitTrigger (ent);
	ent->game.touch = lap_trigger1_touch;
}

void LapTrigger2 (void)
{
	edict_t	*ent;

	ent = miniracer.self;
	
	InitTrigger (ent);
	ent->game.touch = lap_trigger2_touch;
}

void LapTrigger3 (void)
{
	edict_t	*ent;

	ent = miniracer.self;
	
	InitTrigger (ent);
	ent->game.touch = lap_trigger3_touch;
}
