/*
Copyright (C) 2001-2002 Tomas Jakobsson.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include	"../quakedef.h"
#include	"../gl_gentex.h"

gentex_t gentex[NUM_GENTEXES] =
{
	{0,	"curve_h_4-4",	"curve_h_ld_1-1"},
	{0,	"curve_h_4-3",	"curve_h_ld_1-2"},	
	{0,	"curve_h_4-2",	"curve_h_ld_1-3"},
	{0,	"curve_h_3-4",	"curve_h_ld_2-1"},
	{0,	"curve_h_3-3",	"curve_h_ld_2-2"},
	{0,	"curve_h_3-2",	"curve_h_ld_2-3"},
	{0,	"curve_h_3-1",	"curve_h_ld_2-4"},
	{0,	"curve_h_2-2",	"curve_h_ld_3-3"},
	{0,	"curve_h_2-1",	"curve_h_ld_3-4"},
	{0,	"curve_h_1-2",	"curve_h_ld_4-3"},
	{0,	"curve_h_1-1",	"curve_h_ld_4-4"},

	{1,	"curve_h_3-4",	"curve_h_lu_1-3"},
	{1,	"curve_h_4-4",	"curve_h_lu_1-4"},
	{1,	"curve_h_3-3",	"curve_h_lu_2-3"},
	{1,	"curve_h_4-3",	"curve_h_lu_2-4"},
	{1,	"curve_h_1-2",	"curve_h_lu_3-1"},
	{1,	"curve_h_2-2",	"curve_h_lu_3-2"},
	{1,	"curve_h_3-2",	"curve_h_lu_3-3"},
	{1,	"curve_h_4-2",	"curve_h_lu_3-4"},
	{1,	"curve_h_1-1",	"curve_h_lu_4-1"},
	{1,	"curve_h_2-1",	"curve_h_lu_4-2"},
	{1,	"curve_h_3-1",	"curve_h_lu_4-3"},

	{2,	"curve_h_3-1",	"curve_h_rd_1-2"},
	{2,	"curve_h_2-1",	"curve_h_rd_1-3"},
	{2,	"curve_h_1-1",	"curve_h_rd_1-4"},
	{2,	"curve_h_4-2",	"curve_h_rd_2-1"},
	{2,	"curve_h_3-2",	"curve_h_rd_2-2"},
	{2,	"curve_h_2-2",	"curve_h_rd_2-3"},
	{2,	"curve_h_1-2",	"curve_h_rd_2-4"},
	{2,	"curve_h_4-3",	"curve_h_rd_3-1"},
	{2,	"curve_h_3-3",	"curve_h_rd_3-2"},
	{2,	"curve_h_4-4",	"curve_h_rd_4-1"},
	{2,	"curve_h_3-4",	"curve_h_rd_4-2"},
	
	{3,	"curve_h_1-1",	"curve_h_ru_1-1"},
	{3,	"curve_h_1-2",	"curve_h_ru_1-2"},
	{3,	"curve_h_2-1",	"curve_h_ru_2-1"},
	{3,	"curve_h_2-2",	"curve_h_ru_2-2"},
	{3,	"curve_h_3-1",	"curve_h_ru_3-1"},
	{3,	"curve_h_3-2",	"curve_h_ru_3-2"},
	{3,	"curve_h_3-3",	"curve_h_ru_3-3"},
	{3,	"curve_h_3-4",	"curve_h_ru_3-4"},
	{3,	"curve_h_4-2",	"curve_h_ru_4-2"},
	{3,	"curve_h_4-3",	"curve_h_ru_4-3"},
	{3,	"curve_h_4-4",	"curve_h_ru_4-4"},

	{0,	"curve_b_3-3",	"curve_b_ld_1-1"},
	{0,	"curve_b_3-2",	"curve_b_ld_1-2"},
	{0,	"curve_b_3-1",	"curve_b_ld_1-3"},
	{0,	"curve_b_2-3",	"curve_b_ld_2-1"},
	{0,	"curve_b_2-2",	"curve_b_ld_2-2"},
	{0,	"curve_b_2-1",	"curve_b_ld_2-3"},
	{0,	"curve_b_1-2",	"curve_b_ld_3-2"},
	{0,	"curve_b_1-1",	"curve_b_ld_3-3"},

	{1,	"curve_b_2-3",	"curve_b_lu_1-2"},
	{1,	"curve_b_3-3",	"curve_b_lu_1-3"},
	{1,	"curve_b_1-2",	"curve_b_lu_2-1"},
	{1,	"curve_b_2-2",	"curve_b_lu_2-2"},
	{1,	"curve_b_3-2",	"curve_b_lu_2-3"},
	{1,	"curve_b_1-1",	"curve_b_lu_3-1"},
	{1,	"curve_b_2-1",	"curve_b_lu_3-2"},
	{1,	"curve_b_3-1",	"curve_b_lu_3-3"},

	{2,	"curve_b_3-1",	"curve_b_rd_1-1"},
	{2,	"curve_b_2-1",	"curve_b_rd_1-2"},
	{2,	"curve_b_1-1",	"curve_b_rd_1-3"},
	{2,	"curve_b_3-2",	"curve_b_rd_2-1"},
	{2,	"curve_b_2-2",	"curve_b_rd_2-2"},
	{2,	"curve_b_1-2",	"curve_b_rd_2-3"},
	{2,	"curve_b_3-3",	"curve_b_rd_3-1"},
	{2,	"curve_b_2-3",	"curve_b_rd_3-2"},

	{3,	"curve_b_1-1",	"curve_b_ru_1-1"},
	{3,	"curve_b_1-2",	"curve_b_ru_1-2"},
	{3,	"curve_b_2-1",	"curve_b_ru_2-1"},
	{3,	"curve_b_2-2",	"curve_b_ru_2-2"},
	{3,	"curve_b_2-3",	"curve_b_ru_2-3"},
	{3,	"curve_b_3-1",	"curve_b_ru_3-1"},
	{3,	"curve_b_3-2",	"curve_b_ru_3-2"},
	{3,	"curve_b_3-3",	"curve_b_ru_3-3"},


	{0,	"curve_m_2-2",	"curve_m_ld_1-1"},
	{0,	"curve_m_2-1",	"curve_m_ld_1-2"},
	{0,	"curve_m_1-2",	"curve_m_ld_2-1"},
	{0,	"curve_m_1-1",	"curve_m_ld_2-2"},

	{1,	"curve_m_1-2",	"curve_m_lu_1-1"},
	{1,	"curve_m_2-2",	"curve_m_lu_1-2"},
	{1,	"curve_m_1-1",	"curve_m_lu_2-1"},
	{1,	"curve_m_2-1",	"curve_m_lu_2-2"},

	{2,	"curve_m_2-1",	"curve_m_rd_1-1"},
	{2,	"curve_m_1-1",	"curve_m_rd_1-2"},
	{2,	"curve_m_2-2",	"curve_m_rd_2-1"},
	{2,	"curve_m_1-2",	"curve_m_rd_2-2"},

	{3,	"curve_m_1-1",	"curve_m_ru_1-1"},
	{3,	"curve_m_1-2",	"curve_m_ru_1-2"},
	{3,	"curve_m_2-1",	"curve_m_ru_2-1"},
	{3,	"curve_m_2-2",	"curve_m_ru_2-2"},

	{0,	"curve_s",		"curve_s_ld"},
	{1,	"curve_s",		"curve_s_lu"},
	{2,	"curve_s",		"curve_s_rd"},
	{3,	"curve_s",		"curve_s_ru"},

	{0,	"tjunction",	"tjunction_l"},
	{1,	"tjunction",	"tjunction_u"},
	{2,	"tjunction",	"tjunction_d"},
	{3,	"tjunction",	"tjunction_r"},

	{0,	"ground",		"ground"},	

	{0,	"crossroad",	"crossroad"},

	{2,	"road",			"road_lr"},
	{3,	"road",			"road_ud"},

	{4,	"road",			"finishline_lr"},
	{5,	"road",			"finishline_ud"},
};

char	oldscene[32];

byte *LoadMRTData (char* filename, qboolean complain);

void Draw_Shutdown (void);
void Draw_InitTextures (void);

byte	*base_road;
byte	*base_ground;
byte	*finish;

/*
====================
GenerateTextureStart
====================
*/
void GenerateTextureStart (char *scene)
{
	char	roadtex[32];
	char	groundtex[32];
	char	finishtex[32];

	_snprintf (roadtex,		32, "textures/%s/base_road",	scene);
	_snprintf (groundtex,	32, "textures/%s/base_ground",	scene);
	_snprintf (finishtex,	32, "textures/base/finishgrid");

	base_road	= LoadMRTData (roadtex,		true);
	base_ground	= LoadMRTData (groundtex,	true);
	finish		= LoadMRTData (finishtex,	true);

	if (!MR_strcmp (oldscene, scene))
		return;

	Con_Printf ("Deleting\n");
	MR_strcpy (oldscene, scene);
	Draw_Shutdown ();
	Draw_InitTextures ();
}

/*
===================
GenerateTextureStop
===================
*/
void GenerateTextureStop (void)
{
	free (base_road);
	free (base_ground);
	free (finish);
}

/*
===============
GenerateTexture
===============
*/
byte *GenerateTexture (gentex_t *gentex)
{
	byte	*mask;
	byte	*buffer;

	int		x, y, i, mx ,my;
	byte	alpha;
	char	masktex[32];

	buffer = malloc (256*256*4);

	_snprintf (masktex,	sizeof(masktex), "textures/base/%s", gentex->base);

	mask = LoadMRTData (masktex, true);

	if (!mask || !base_road || !base_ground)
		return 0;

	i = 0;

	if (gentex->num == 0)
	{
		for (y=255; y>=0; y--)
		{
			for (x=255; x>=0; x--)
			{
				mx		= (int)(x * 0.5);
				my		= (int)(y * 0.5);

				alpha	= mask[((my * 128) + mx) * 4];

				buffer[i+0] = ((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255;
				buffer[i+1] = ((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255;
				buffer[i+2] = ((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255;
				buffer[i+3] = 255;

				i +=4;
			}
		}
	}
	else if (gentex->num == 1)
	{
		for (y=255; y>=0; y--)
		{
			for (x=0; x<256; x++)
			{
				mx		= (int)(y * 0.5);
				my		= (int)(x * 0.5);

				alpha	= mask[((my * 128) + mx) * 4];

				buffer[i+0] = ((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255;
				buffer[i+1] = ((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255;
				buffer[i+2] = ((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255;
				buffer[i+3] = 255;

				i +=4;
			}
		}
	}
	else if (gentex->num == 2)
	{
		for (y=0; y<256; y++)
		{
			for (x=255; x>=0; x--)
			{
				mx		= (int)(y * 0.5);
				my		= (int)(x * 0.5);

				alpha	= mask[((my * 128) + mx) * 4];

				buffer[i+0] = ((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255;
				buffer[i+1] = ((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255;
				buffer[i+2] = ((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255;
				buffer[i+3] = 255;

				i +=4;
			}
		}
	}
	else if (gentex->num == 3)
	{
		for (y=0; y<256; y++)
		{
			for (x=0; x<256; x++)
			{
				mx		= (int)(x * 0.5);
				my		= (int)(y * 0.5);

				alpha	= mask[((my * 128) + mx) * 4];

				buffer[i+0] = ((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255;
				buffer[i+1] = ((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255;
				buffer[i+2] = ((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255;
				buffer[i+3] = 255;

				i +=4;
			}
		}
	}
	else if (gentex->num == 4)
	{
		int		addgrid;

		if (!finish)
			return 0;

		for (y=0; y<256; y++)
		{
			for (x=0; x<256; x++)
			{
				mx		= y;
				my		= 255 - x;

				if (mx)
					mx	= (int)(mx*0.5);
				if (my)
					my	= (int)(my*0.5);

				alpha	= mask[((my * 128) + mx) * 4];
				addgrid	= 0;

				if (finish[((my * 128) + mx) * 4] == 127)
					addgrid = -32;
				if (finish[((my * 128) + mx) * 4] == 255)
					addgrid = +32;

				buffer[i+0] = ((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255 + addgrid;
				buffer[i+1] = ((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255 + addgrid;
				buffer[i+2] = ((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255 + addgrid;
				buffer[i+3] = 255;

				if (((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255 + addgrid > 255)	buffer[i+0] = 255;
				if (((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255 + addgrid < 0)	buffer[i+0] = 0;
				if (((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255 + addgrid > 255)	buffer[i+1] = 255;
				if (((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255 + addgrid < 0)	buffer[i+1] = 0;
				if (((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255 + addgrid > 255)	buffer[i+2] = 255;
				if (((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255 + addgrid < 0)	buffer[i+2] = 0;

				i +=4;
			}
		}
	}
	else if (gentex->num == 5)
	{
		int		addgrid;

		if (!finish)
			return 0;

		for (y=0; y<256; y++)
		{
			for (x=0; x<256; x++)
			{
				mx		= x;
				my		= y;

				if (mx)
					mx	= (int)(mx*0.5);
				if (my)
					my	= (int)(my*0.5);

				alpha	= mask[((my * 128) + mx) * 4];
				addgrid	= 0;

				if (finish[((my * 128) + mx) * 4] == 127)
					addgrid = -32;
				if (finish[((my * 128) + mx) * 4] == 255)
					addgrid = +32;

				buffer[i+0] = ((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255 + addgrid;
				buffer[i+1] = ((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255 + addgrid;
				buffer[i+2] = ((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255 + addgrid;
				buffer[i+3] = 255;

				if (((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255 + addgrid > 255)	buffer[i+0] = 255;
				if (((base_ground[i+0] * alpha) + (base_road[i+0] * (255 - alpha))) / 255 + addgrid < 0)	buffer[i+0] = 0;
				if (((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255 + addgrid > 255)	buffer[i+1] = 255;
				if (((base_ground[i+1] * alpha) + (base_road[i+1] * (255 - alpha))) / 255 + addgrid < 0)	buffer[i+1] = 0;
				if (((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255 + addgrid > 255)	buffer[i+2] = 255;
				if (((base_ground[i+2] * alpha) + (base_road[i+2] * (255 - alpha))) / 255 + addgrid < 0)	buffer[i+2] = 0;


				i +=4;
			}
		}
	}

	free (mask);

	return buffer;
}
