/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include	"../quakedef.h"

/*
======
R_Init
======
*/
void R_Init (void)
{	
	extern	cvar_t	numbots;
	extern	cvar_t	numlaps;
	extern	cvar_t	draw_sky;
	extern	cvar_t	gl_picmip;
	extern	cvar_t	gl_shadow;
	extern	cvar_t	draw_water;
	extern	cvar_t	_timeofday;

	Cvar_RegisterVariable (&numbots);
	Cvar_RegisterVariable (&numlaps);
	Cvar_RegisterVariable (&draw_sky);
	Cvar_RegisterVariable (&gl_picmip);
	Cvar_RegisterVariable (&gl_shadow);
	Cvar_RegisterVariable (&draw_water);
	Cvar_RegisterVariable (&_timeofday);
}

void GL_ClearSkids (void);
void GL_ClearSmoke (void);

/*
========
R_NewMap
========
*/
void R_NewMap (void)
{
	int		i;

	r_viewleaf = NULL;

	GL_ClearSkids ();
	GL_ClearSmoke ();

	GL_BuildLightmaps ();

	for (i=0; i<cl.worldmodel->numtextures; i++)
	{
		if (!cl.worldmodel->textures[i])
			continue;
 		cl.worldmodel->textures[i]->texturechain = NULL;
	}
}
